> ## Documentation Index
> Fetch the complete documentation index at: https://developer.fabric.inc/llms.txt
> Use this file to discover all available pages before exploring further.

# Update customer details - customer context

> Using this endpoint, customers can update their own details through the storefront UI.



## OpenAPI

````yaml customers.openapi put /customers/self
openapi: 3.0.0
info:
  title: Customers
  description: >-
    The fabric **Customers** API is used to create and manage details of
    storefront customers, also referred to as shoppers. The `Customers` or
    `Customer Address` APIs provide features for store admins to manage their
    customers' details and addresses. The `Customer Self' API provide features
    for customers or shoppers to independently manage their own details.
  version: 3.0.0
  x-audience: external-public
  contact:
    name: fabric Support
    email: support@fabric.inc
  license:
    name: fabric API License
    url: https://fabric.inc/api-license
  termsOfService: https://fabric.inc/terms-of-use
servers:
  - url: https://api.fabric.inc/v3
    description: Production
security:
  - bearerAuth: []
tags:
  - name: Customer Profile
    description: >-
      These endpoints provide the features for store admins to create and manage
      customers' details.
  - name: Customer Address
    description: >-
      These endpoints provide the features for store admins to create and manage
      customers' addresses.
  - name: Customer Self
    description: >-
      These endpoints provide the feature for customers or shoppers to
      independently manage their details in the storefront.
paths:
  /customers/self:
    parameters:
      - name: x-fabric-tenant-id
        in: header
        description: >-
          A header used by fabric to identify the tenant making the request. You
          must include tenant id in the authentication header for an API request
          to access any of fabric’s endpoints. You can retrieve the tenant id ,
          which is also called account id, from
          [Copilot](/v3/platform/settings/account-details/getting-the-account-id).
          This header is required.
        schema:
          type: string
          example: 517fa9dfd42d8b00g1o3k312
      - name: x-fabric-request-id
        in: header
        description: Unique request ID
        schema:
          type: string
        example: 263e731c-45c8-11ed-b878-0242ac120002
        required: false
    put:
      tags:
        - Customer Self
      summary: Update customer details - customer context
      description: >-
        Using this endpoint, customers can update their own details through the
        storefront UI.
      operationId: updateCustomerSelf
      requestBody:
        description: A sample request to update customer's details.
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/updateCustomerSelfRequest'
        required: true
      responses:
        '200':
          description: OK
          headers:
            x-fabric-request-id:
              $ref: dae96e30-e72e-4091-be69-ce7f63e78aa2
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/customer'
        '400':
          $ref: '#/components/responses/badRequest'
        '403':
          $ref: '#/components/responses/forbidden'
        '404':
          $ref: '#/components/responses/customerNotFound'
        '500':
          $ref: '#/components/responses/internalServerError'
components:
  schemas:
    updateCustomerSelfRequest:
      type: object
      required:
        - name
        - emailAddress
      properties:
        name:
          $ref: '#/components/schemas/updateCommonNameRequest'
        emailAddress:
          type: string
          description: The customer's email.
          format: email
          example: test@example.com
        phone:
          $ref: '#/components/schemas/phone'
        additionalAttributes:
          description: A placeholder for additional info, in key-value pairs.
          type: object
          example:
            middleName: user
    customer:
      required:
        - id
        - isDeleted
        - createdAt
        - updatedAt
        - name
        - emailAddress
      type: object
      properties:
        id:
          type: string
          description: A 24-character system-generated ID of the customer.
          uniqueItems: true
          example: 61df41892bf06d00092d0d8a
        name:
          $ref: '#/components/schemas/commonName'
        status:
          description: The account status of the customer.
          type: string
          enum:
            - ACTIVE
            - INACTIVE
            - BLOCKED
          example: ACTIVE
        emailAddress:
          type: string
          description: The customer's email.
          format: email
          example: test@example.com
        phone:
          $ref: '#/components/schemas/phone'
        externalId:
          type: string
          description: A UUID of the customer.
          example: 1231012312-312-31231asda
        additionalAttributes:
          description: A placeholder for additional info, in key-value pairs.
          type: object
          example:
            middleName: user
        isDeleted:
          type: boolean
          description: >-
            A flag indicating whether the customer's record is deleted. `true`
            indicates, the customer's record is deleted and false indicates
            otherwise.
          example: false
        deletedAt:
          description: The time when the customer's record was deleted, in UTC format.
          type: string
          format: date-time
          example: '2023-08-30T23:20:42.822Z'
          nullable: true
        createdAt:
          description: The time when the customer was added to the system, in UTC format.
          type: string
          format: date-time
          example: '2023-08-30T23:20:42.822Z'
        updatedAt:
          description: The time when the customer data was last updated, in UTC format.
          type: string
          format: date-time
          example: '2023-08-30T23:20:42.822Z'
          nullable: true
        defaultAddress:
          description: The default addresses of the customer.
          type: array
          items:
            $ref: '#/components/schemas/customerAddressResponse'
    updateCommonNameRequest:
      type: object
      description: The customer's full name.
      properties:
        title:
          description: The customer's title, such as Mr., Mrs, Dr, and more.
          type: string
          example: Dr.
        firstName:
          description: The customer's first name.
          type: string
          example: Pat
        middleName:
          description: The customer's middle name or initial.
          type: string
          example: E
        lastName:
          description: The customer's last name.
          type: string
          example: Kake
        suffix:
          description: The suffix for the customer's name, such as Jr., PhD, and more.
          type: string
          example: Jr.
    phone:
      type: object
      properties:
        number:
          type: string
          description: The customer's phone number.
          example: 15555551234
        type:
          type: string
          description: The type of phone number.
          example: MOBILE
          nullable: true
          enum:
            - MOBILE
            - HOME
            - BUSINESS
    commonName:
      type: object
      description: The full name of the customer.
      required:
        - firstName
        - lastName
      properties:
        title:
          description: The customer's title, such as Mr., Mrs, and Dr.
          type: string
          example: Dr.
        firstName:
          description: The customer's first name.
          type: string
          example: Pat
        middleName:
          description: The customer's middle name.
          type: string
          example: E
        lastName:
          description: The customer's last name.
          type: string
          example: Doe
        suffix:
          description: The suffix for the customer's name, such as Jr., PhD, and more.
          type: string
          example: Jr.
    customerAddressResponse:
      required:
        - id
        - address
        - isDeleted
        - createdAt
        - updatedAt
      type: object
      properties:
        id:
          type: string
          description: A 24-character system-generated ID of the address.
          example: 61604a30fdfacd0009816e44
          uniqueItems: true
        address:
          $ref: '#/components/schemas/commonAddress'
        additionalAttributes:
          description: A placeholder for additional info, in key-value pairs.
          type: object
          example:
            landmark: Beach
        isDeleted:
          type: boolean
          description: >-
            A flag indicating whether the address is deleted. `true` indicates
            the address is deleted and `false` indicates otherwise.
          example: false
        isDefault:
          description: >-
            A flag indicating whether the address is the default one.`true`
            indicates the given address is the default address and `false`
            indicates otherwise.
          type: boolean
          example: false
        deletedAt:
          description: The time when the address was deleted, in UTC format.
          type: string
          format: date-time
          example: '2023-08-30T23:20:42.822Z'
          nullable: true
        createdAt:
          description: The time when the address was created, in UTC format.
          type: string
          format: date-time
          example: '2023-08-30T23:20:42.822Z'
        updatedAt:
          description: The time when the address was the last updated, in UTC format.
          type: string
          format: date-time
          example: '2023-08-30T23:20:42.822Z'
          nullable: true
    message:
      description: The response message.
      type: object
      properties:
        type:
          description: A machine-readable code.
          type: string
          example: SUCCESS
        message:
          description: A human-friendly message corresponding to the `type`.
          type: string
          example: Success message
      required:
        - type
        - message
    commonAddress:
      type: object
      description: The address details.
      required:
        - type
      properties:
        addressLine1:
          description: The first line of the address.
          type: string
          example: 123 Main St.
        addressLine2:
          description: The second line of the address.
          type: string
          example: Suite 100
        addressLine3:
          description: The third line of the address.
          type: string
          example: Seventh floor
        addressLine4:
          description: The fourth line of the address.
          type: string
          example: 'Attention: Pat E. Doe'
        city:
          description: The city name in the address.
          type: string
          example: Seattle
        region:
          description: The region or state name in the address.
          type: string
          example: WA
        postalCode:
          description: The postal or ZIP code of the address.
          type: string
          example: 98121
        county:
          description: The administrative division or county within a country or state.
          type: string
          example: King County
        country:
          description: >-
            The country code, which can be a full name, or an ISO 3166-1 alpha-2
            or alpha-3 code.
          type: string
          example: US
        type:
          description: The address type.
          type: string
          enum:
            - BILLING
            - SHIPPING
          example: BILLING
        latitude:
          description: >-
            The geographical `latitude` used with `longitude` to locate the
            exact address. The coordinates are provided in decimal degrees
            format, with negative values indicating locations to the west.
          type: number
          format: double
          example: 47.6205
        longitude:
          description: >-
            The geographical `longitude` used with `latitude` to locate the
            exact address. The coordinates are provided in decimal degrees
            format, with negative values indicating locations to the west.
          type: number
          format: double
          example: -122.3493
  responses:
    badRequest:
      description: Bad request
      headers:
        x-fabric-request-id:
          $ref: dae96e30-e72e-4091-be69-ce7f63e78aa2
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/message'
          examples:
            invalidAccountProvided:
              value:
                type: INVALID_ACCOUNT_PROVIDED
                message: Invalid account provided for the request.
    forbidden:
      description: Forbidden Request
      headers:
        x-fabric-request-id:
          description: Unique request ID
          schema:
            type: string
            example: 263e731c-45c8-11ed-b878-0242ac120002
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/message'
          example:
            type: REQUEST_DENIED
            message: Forbidden
    customerNotFound:
      description: The resource isn't found
      headers:
        x-fabric-request-id:
          $ref: dae96e30-e72e-4091-be69-ce7f63e78aa2
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/message'
          example:
            type: CUSTOMER_NOT_FOUND
            message: Data with the given identifier isn't found
    internalServerError:
      description: The request is received but an internal error occurred
      headers:
        x-fabric-request-id:
          $ref: dae96e30-e72e-4091-be69-ce7f63e78aa2
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/message'
          example:
            type: INTERNAL_SERVER_ERROR
            message: Internal server error
  securitySchemes:
    bearerAuth:
      description: The access token.
      type: http
      scheme: bearer
      bearerFormat: JWT

````